// This JavaScript code defines several functions for changing the title and icon of a web page and for resetting the title and icon to their default values. It also includes a function for validating URLs.
// The code begins by setting the focus on an element with the ID "userinput" and defining some variables that reference elements with specific IDs.
// It then defines the changeTabTitle function, which gets the value of an element with the ID "userinput" and uses it to set the title of the current web page and the value of the "title" item in local storage. If the input is blank, it removes the "title" item from local storage and sets the title of the page to the default. It also logs a message to an element with the ID "console-output" and changes the color of the text to reflect the success or failure of the operation.
// The changeTabIcon function does the same thing for the icon of the web page, using the querySelector method to select the link element with a "rel" attribute of "icon" and setting its "href" attribute to the value of the input. It also uses the validURL function to validate the input as a URL before making the change.
// The resetTabSettings function removes the "icon" and "title" items from local storage and reloads the page.
// The applyUrl function sets the value of the input and applies the changeTabIcon and changeTabTitle functions to it. It also logs a message to the "console-output" element and changes the color of the text to green.
// The validURL function takes in a string str and uses a regular expression to test if it is a valid URL. It returns true if the string is a valid URL and false if it is not.
// Help generated by ChatGPT

//Autofocus without scroll
document.querySelector("#userinput").focus({
    preventScroll: true
  });

  const image_preview = document.getElementById("image-preview");
  const console_output = document.getElementById("console-output");
  
  //Change tabTitle
  const changeTabTitle = () => {
    const newtitle = document.getElementById("userinput");
    if (newtitle.value == ""){ //check if the input is blank when they submit
        window.localStorage.removeItem("title");
        window.document.title = "3kh0.github.io"
        document.getElementById("console-output").style.color = "red"; //error = red
        console_output.innerText = "No title entered. Default applied" //return output successful
    } else {
        window.localStorage.setItem("title", newtitle.value);
        window.document.title = newtitle.value; //Set window's title to userinput
        document.getElementById("console-output").style.color = "green"; //reset output's color to green
        console_output.innerText = "Title change successful" //return output successful
    }
    newtitle.value = ""; //clear input
  };
  
  //Change the tabIcon
  const changeTabIcon = () => {
    const newfavicon = document.getElementById("userinput");
    if (validURL(newfavicon.value)){
        document.querySelector("link[rel*='icon']").href = newfavicon.value;
        window.localStorage.setItem("icon", newfavicon.value);
        document.getElementById("console-output").style.color = "green";
        console_output.innerText = "Icon change successful"
    } else {
        document.getElementById("console-output").style.color = "red";
        console_output.innerText = "Icon change failed. Make sure you are using a valid URL"
    }
    newfavicon.value = ""; //clear input
  };
  
  //URL Validation Regex
  const validURL = (str) => {
    var expression = /(https?:\/\/(?:www\.|(?!www))[a-zA-Z0-9][a-zA-Z0-9-]+[a-zA-Z0-9]\.[^\s]{2,}|www\.[a-zA-Z0-9][a-zA-Z0-9-]+[a-zA-Z0-9]\.[^\s]{2,}|https?:\/\/(?:www\.|(?!www))[a-zA-Z0-9]+\.[^\s]{2,}|www\.[a-zA-Z0-9]+\.[^\s]{2,})/gi;
    var regex = new RegExp(expression);
    return !!regex.test(str);
  }
  
  //Clears Tab Icon and Title
  const resetTabSettings = () => {
    let items = ["icon", "title"];
    items.forEach(item =>
    window.localStorage.removeItem(item));
    document.getElementById("console-output").style.color = "black";
    console_output.innerText = "Resetting..."
    window.location.reload();
  };
  
  // Handle Apply buttons
  
  function applyUrl(url, title){
  document.getElementById("userinput").value = url;
  changeTabIcon();
  document.getElementById("userinput").value = title;
  changeTabTitle();
  document.getElementById("console-output").style.color = "green";
  console_output.innerText = "Preset applied successfully!"
  }